--- ./cli/processexecutor.cpp.orig	2025-05-09 12:44:13.202623266 -0500
+++ ./cli/processexecutor.cpp	2025-05-09 12:44:53.702249529 -0500
@@ -216,7 +216,7 @@
 
 bool ProcessExecutor::checkLoadAverage(size_t nchildren)
 {
-#if defined(__QNX__) || defined(__HAIKU__)  // getloadavg() is unsupported on Qnx, Haiku.
+#if defined(__QNX__) || defined(__HAIKU__) || defined(_AIX)  // getloadavg() is unsupported on Qnx, Haiku.
     (void)nchildren;
     return true;
 #else
--- ./externals/simplecpp/simplecpp.cpp.orig	2025-05-09 12:46:32.467367160 -0500
+++ ./externals/simplecpp/simplecpp.cpp	2025-05-09 12:50:38.922271481 -0500
@@ -3394,9 +3394,9 @@
     }
 
     // True => code in current #if block should be kept
-    // ElseIsTrue => code in current #if block should be dropped. the code in the #else should be kept.
-    // AlwaysFalse => drop all code in #if and #else
-    enum IfState { True, ElseIsTrue, AlwaysFalse };
+    // Else_is_true => code in current #if block should be dropped. the code in the #else should be kept.
+    // Always_false => drop all code in #if and #else
+    enum IfState { True, Else_is_true, Always_false };
     std::stack<int> ifstates;
     ifstates.push(True);
 
@@ -3579,7 +3579,7 @@
                 }
 
                 bool conditionIsTrue;
-                if (ifstates.top() == AlwaysFalse || (ifstates.top() == ElseIsTrue && rawtok->str() != ELIF))
+                if (ifstates.top() == Always_false || (ifstates.top() == Else_is_true && rawtok->str() != ELIF))
                     conditionIsTrue = false;
                 else if (rawtok->str() == IFDEF) {
                     conditionIsTrue = (macros.find(rawtok->next->str()) != macros.end() || (hasInclude && rawtok->next->str() == HAS_INCLUDE));
@@ -3708,16 +3708,16 @@
                 if (rawtok->str() != ELIF) {
                     // push a new ifstate..
                     if (ifstates.top() != True)
-                        ifstates.push(AlwaysFalse);
+                        ifstates.push(Always_false);
                     else
-                        ifstates.push(conditionIsTrue ? True : ElseIsTrue);
+                        ifstates.push(conditionIsTrue ? True : Else_is_true);
                 } else if (ifstates.top() == True) {
-                    ifstates.top() = AlwaysFalse;
-                } else if (ifstates.top() == ElseIsTrue && conditionIsTrue) {
+                    ifstates.top() = Always_false;
+                } else if (ifstates.top() == Else_is_true && conditionIsTrue) {
                     ifstates.top() = True;
                 }
             } else if (rawtok->str() == ELSE) {
-                ifstates.top() = (ifstates.top() == ElseIsTrue) ? True : AlwaysFalse;
+                ifstates.top() = (ifstates.top() == Else_is_true) ? True : Always_false;
             } else if (rawtok->str() == ENDIF) {
                 ifstates.pop();
             } else if (rawtok->str() == UNDEF) {
--- ./lib/checkclass.cpp.orig	2025-05-09 12:51:57.822242798 -0500
+++ ./lib/checkclass.cpp	2025-05-09 12:54:14.722241297 -0500
@@ -22,7 +22,7 @@
 #include "astutils.h"
 #include "library.h"
 #include "settings.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "symboldatabase.h"
 #include "errorlogger.h"
 #include "errortypes.h"
@@ -1836,12 +1836,12 @@
                                                      || (Token::simpleMatch(itr->astOperand2(), "this") && Token::simpleMatch(itr->astOperand1(), "&") && Token::simpleMatch(itr->astOperand1()->next(), rhs->str().c_str(), rhs->str().size())))) {
             //Do nothing
         } else {
-            return Bool::BAILOUT;
+            return Bool::Bailout;
         }
     }
     if (res)
-        return Bool::TRUE;
-    return Bool::FALSE;
+        return Bool::True;
+    return Bool::False;
 }
 
 const Token * CheckClass::getIfStmtBodyStart(const Token *tok, const Token *rhs)
@@ -1849,11 +1849,11 @@
     const Token *top = tok->astTop();
     if (Token::simpleMatch(top->link(), ") {")) {
         switch (isInverted(tok->astParent(), rhs)) {
-        case Bool::BAILOUT:
+        case Bool::Bailout:
             return nullptr;
-        case Bool::TRUE:
+        case Bool::True:
             return top->link()->next();
-        case Bool::FALSE:
+        case Bool::False:
             return top->link()->linkAt(1);
         }
     }
--- ./lib/checkclass.h.orig	2025-05-09 12:55:17.122241771 -0500
+++ ./lib/checkclass.h	2025-05-09 12:55:58.458374842 -0500
@@ -223,7 +223,7 @@
     bool hasAllocation(const Function *func, const Scope* scope, const Token *start, const Token *end) const;
     bool hasAllocationInIfScope(const Function *func, const Scope* scope, const Token *ifStatementScopeStart) const;
     static bool hasAssignSelf(const Function *func, const Token *rhs, const Token *&out_ifStatementScopeStart);
-    enum class Bool : std::uint8_t { TRUE, FALSE, BAILOUT };
+    enum class Bool : std::uint8_t { True, False, Bailout };
     static Bool isInverted(const Token *tok, const Token *rhs);
     static const Token * getIfStmtBodyStart(const Token *tok, const Token *rhs);
 
--- ./lib/checkfunctions.cpp.orig	2025-05-09 12:57:15.222240616 -0500
+++ ./lib/checkfunctions.cpp	2025-05-09 12:57:40.322238914 -0500
@@ -28,7 +28,7 @@
 #include "mathlib.h"
 #include "platform.h"
 #include "settings.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "symboldatabase.h"
 #include "token.h"
 #include "tokenize.h"
--- ./lib/checkother.cpp.orig	2025-05-09 12:58:29.222240882 -0500
+++ ./lib/checkother.cpp	2025-05-09 12:58:57.422239839 -0500
@@ -26,7 +26,7 @@
 #include "mathlib.h"
 #include "platform.h"
 #include "settings.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "symboldatabase.h"
 #include "token.h"
 #include "tokenize.h"
--- ./lib/checkstl.cpp.orig	2025-05-09 12:59:53.431054472 -0500
+++ ./lib/checkstl.cpp	2025-05-09 13:00:08.922239909 -0500
@@ -24,7 +24,7 @@
 #include "mathlib.h"
 #include "pathanalysis.h"
 #include "settings.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "symboldatabase.h"
 #include "token.h"
 #include "tokenize.h"
--- ./lib/checktype.cpp.orig	2025-05-09 13:01:08.143712213 -0500
+++ ./lib/checktype.cpp	2025-05-09 13:01:24.222385810 -0500
@@ -25,7 +25,7 @@
 #include "mathlib.h"
 #include "platform.h"
 #include "settings.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "symboldatabase.h"
 #include "token.h"
 #include "tokenize.h"
--- ./lib/cppcheck.cpp.orig	2025-05-09 13:02:23.922242579 -0500
+++ ./lib/cppcheck.cpp	2025-05-09 13:02:44.222239725 -0500
@@ -33,7 +33,7 @@
 #include "platform.h"
 #include "preprocessor.h"
 #include "settings.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "suppressions.h"
 #include "timer.h"
 #include "token.h"
--- ./lib/cppcheck.h.orig	2025-05-09 13:03:31.963909555 -0500
+++ ./lib/cppcheck.h	2025-05-09 13:03:48.122246880 -0500
@@ -23,7 +23,7 @@
 
 #include "check.h"
 #include "config.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 
 #include <cstdint>
 #include <fstream>
--- ./lib/cppcheck.vcxproj.filters.orig	2025-05-09 13:04:39.922240913 -0500
+++ ./lib/cppcheck.vcxproj.filters	2025-05-09 13:04:57.922240840 -0500
@@ -496,7 +496,7 @@
     <ClInclude Include="smallvector.h">
       <Filter>Header Files</Filter>
     </ClInclude>
-    <ClInclude Include="standards.h">
+    <ClInclude Include="cppcheckstd.h">
       <Filter>Header Files</Filter>
     </ClInclude>
     <ClInclude Include="valueptr.h">
--- ./lib/cppcheck.vcxproj.orig	2025-05-09 13:09:10.722239644 -0500
+++ ./lib/cppcheck.vcxproj	2025-05-09 13:09:40.722241643 -0500
@@ -159,7 +159,7 @@
     <ClInclude Include="settings.h" />
     <ClInclude Include="smallvector.h" />
     <ClInclude Include="sourcelocation.h" />
-    <ClInclude Include="standards.h" />
+    <ClInclude Include="cppcheckstd.h" />
     <ClInclude Include="summaries.h" />
     <ClInclude Include="suppressions.h" />
     <ClInclude Include="symboldatabase.h" />
--- ./lib/filesettings.h.orig	2025-05-09 13:12:07.322239702 -0500
+++ ./lib/filesettings.h	2025-05-09 13:12:27.722851492 -0500
@@ -22,7 +22,7 @@
 #include "config.h"
 #include "path.h"
 #include "platform.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 
 #include <list>
 #include <set>
--- ./lib/importproject.cpp.orig	2025-05-09 13:13:29.222479420 -0500
+++ ./lib/importproject.cpp	2025-05-09 13:13:45.355996707 -0500
@@ -20,7 +20,7 @@
 
 #include "path.h"
 #include "settings.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "suppressions.h"
 #include "token.h"
 #include "tokenlist.h"
--- ./lib/library.h.orig	2025-05-09 13:14:46.222492470 -0500
+++ ./lib/library.h	2025-05-09 13:15:01.622249643 -0500
@@ -23,7 +23,7 @@
 
 #include "config.h"
 #include "mathlib.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "utils.h"
 
 #include <array>
--- ./lib/path.h.orig	2025-05-09 13:15:31.832251828 -0500
+++ ./lib/path.h	2025-05-09 13:15:46.222250277 -0500
@@ -22,7 +22,7 @@
 //---------------------------------------------------------------------------
 
 #include "config.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 
 #include <set>
 #include <string>
--- ./lib/platform.h.orig	2025-05-09 13:16:18.122354063 -0500
+++ ./lib/platform.h	2025-05-09 13:16:33.322248638 -0500
@@ -23,7 +23,7 @@
 
 #include "config.h"
 #include "mathlib.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 
 #include <cassert>
 #include <climits>
--- ./lib/preprocessor.cpp.orig	2025-05-09 13:17:09.940031977 -0500
+++ ./lib/preprocessor.cpp	2025-05-09 13:17:24.222528240 -0500
@@ -25,7 +25,7 @@
 #include "path.h"
 #include "platform.h"
 #include "settings.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "suppressions.h"
 #include "utils.h"
 
--- ./lib/settings.h.orig	2025-05-09 13:17:55.622250323 -0500
+++ ./lib/settings.h	2025-05-09 13:18:14.161137431 -0500
@@ -26,7 +26,7 @@
 #include "errortypes.h"
 #include "library.h"
 #include "platform.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "checkers.h"
 
 #include <algorithm>
--- ./lib/symboldatabase.cpp.orig	2025-05-09 13:18:50.182220672 -0500
+++ ./lib/symboldatabase.cpp	2025-05-09 13:19:04.822253482 -0500
@@ -28,7 +28,7 @@
 #include "path.h"
 #include "platform.h"
 #include "settings.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "templatesimplifier.h"
 #include "token.h"
 #include "tokenize.h"
--- ./lib/templatesimplifier.cpp.orig	2025-05-09 13:19:41.222477650 -0500
+++ ./lib/templatesimplifier.cpp	2025-05-09 13:19:56.422251963 -0500
@@ -22,7 +22,7 @@
 #include "errortypes.h"
 #include "mathlib.h"
 #include "settings.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "token.h"
 #include "tokenize.h"
 #include "tokenlist.h"
--- ./lib/tokenize.cpp.orig	2025-05-09 13:20:28.922248785 -0500
+++ ./lib/tokenize.cpp	2025-05-09 13:20:43.522251103 -0500
@@ -28,7 +28,7 @@
 #include "platform.h"
 #include "preprocessor.h"
 #include "settings.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "summaries.h"
 #include "symboldatabase.h"
 #include "templatesimplifier.h"
--- ./lib/tokenlist.cpp.orig	2025-05-09 13:21:01.242742641 -0500
+++ ./lib/tokenlist.cpp	2025-05-09 13:21:24.522248712 -0500
@@ -28,7 +28,7 @@
 #include "path.h"
 #include "platform.h"
 #include "settings.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "token.h"
 
 #include <cctype>
--- ./lib/valueflow.cpp.orig	2025-05-09 13:21:41.463903872 -0500
+++ ./lib/valueflow.cpp	2025-05-09 13:22:00.522249183 -0500
@@ -96,7 +96,7 @@
 #include "settings.h"
 #include "smallvector.h"
 #include "sourcelocation.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "symboldatabase.h"
 #include "timer.h"
 #include "token.h"
--- ./test/testcmdlineparser.cpp.orig	2025-05-12 09:29:24.162602839 -0500
+++ ./test/testcmdlineparser.cpp	2025-05-12 09:29:44.608379879 -0500
@@ -27,7 +27,7 @@
 #include "platform.h"
 #include "redirect.h"
 #include "settings.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "suppressions.h"
 #include "fixture.h"
 #include "timer.h"
--- ./test/testconstructors.cpp.orig	2025-05-12 09:31:00.862250421 -0500
+++ ./test/testconstructors.cpp	2025-05-12 09:31:19.462251837 -0500
@@ -20,7 +20,7 @@
 #include "errortypes.h"
 #include "fixture.h"
 #include "helpers.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "settings.h"
 
 #include <cstddef>
--- ./test/testfunctions.cpp.orig	2025-05-12 09:32:53.183632856 -0500
+++ ./test/testfunctions.cpp	2025-05-12 09:33:12.462254980 -0500
@@ -22,7 +22,7 @@
 #include "helpers.h"
 #include "platform.h"
 #include "settings.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 
 #include <cstddef>
 #include <string>
--- ./test/testlibrary.cpp.orig	2025-05-12 09:33:59.462250043 -0500
+++ ./test/testlibrary.cpp	2025-05-12 09:34:15.162257045 -0500
@@ -21,7 +21,7 @@
 #include "helpers.h"
 #include "library.h"
 #include "settings.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "token.h"
 #include "tokenlist.h"
 
--- ./test/testother.cpp.orig	2025-05-12 09:35:01.425989406 -0500
+++ ./test/testother.cpp	2025-05-12 09:35:14.862248819 -0500
@@ -22,7 +22,7 @@
 #include "helpers.h"
 #include "platform.h"
 #include "settings.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "tokenize.h"
 
 #include <cstddef>
--- ./test/testsimplifytokens.cpp.orig	2025-05-12 09:35:51.562251715 -0500
+++ ./test/testsimplifytokens.cpp	2025-05-12 09:36:05.662089630 -0500
@@ -20,7 +20,7 @@
 #include "helpers.h"
 #include "platform.h"
 #include "settings.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "fixture.h"
 #include "token.h"
 
--- ./test/teststl.cpp.orig	2025-05-12 09:36:37.686357700 -0500
+++ ./test/teststl.cpp	2025-05-12 09:36:50.881845730 -0500
@@ -21,7 +21,7 @@
 #include "fixture.h"
 #include "helpers.h"
 #include "settings.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "utils.h"
 
 #include <cstddef>
--- ./test/testtype.cpp.orig	2025-05-12 09:53:31.622391080 -0500
+++ ./test/testtype.cpp	2025-05-12 09:53:47.622419910 -0500
@@ -22,7 +22,7 @@
 #include "helpers.h"
 #include "platform.h"
 #include "settings.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "tokenize.h"
 
 #include <cstddef>
--- ./test/testvarid.cpp.orig	2025-05-12 09:54:38.685612200 -0500
+++ ./test/testvarid.cpp	2025-05-12 09:54:53.162241237 -0500
@@ -19,7 +19,7 @@
 #include "helpers.h"
 #include "platform.h"
 #include "settings.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "fixture.h"
 #include "token.h"
 #include "tokenize.h"
--- ./test/testtokenize.cpp.orig	2025-05-12 10:06:12.862240908 -0500
+++ ./test/testtokenize.cpp	2025-05-12 10:06:26.362241247 -0500
@@ -22,7 +22,7 @@
 #include "platform.h"
 #include "preprocessor.h" // usually tests here should not use preprocessor...
 #include "settings.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "token.h"
 #include "tokenize.h"
 #include "tokenlist.h"
--- ./lib/tokenlist.h.orig	2025-05-19 06:14:48.780301590 -0500
+++ ./lib/tokenlist.h	2025-05-19 06:15:04.058578187 -0500
@@ -22,7 +22,7 @@
 //---------------------------------------------------------------------------
 
 #include "config.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 
 #include <cstddef>
 #include <iosfwd>
--- ./lib/keywords.h.orig	2025-05-19 06:20:44.123046161 -0500
+++ ./lib/keywords.h	2025-05-19 06:21:04.428485970 -0500
@@ -19,7 +19,7 @@
 #ifndef keywordsH
 #define keywordsH
 
-#include "standards.h"
+#include "cppcheckstd.h"
 
 #include <string>
 #include <unordered_set>
--- ./lib/standards.cpp.orig	2025-05-19 06:23:02.473101299 -0500
+++ ./lib/standards.cpp	2025-05-19 06:23:17.288256376 -0500
@@ -16,7 +16,7 @@
  * along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "utils.h"
 
 #include <utility>