--- ./lib/checkclass.cpp.orig	2025-05-09 12:51:57.822242798 -0500
+++ ./lib/checkclass.cpp	2025-05-09 12:54:14.722241297 -0500
@@ -22,7 +22,7 @@
 #include "astutils.h"
 #include "library.h"
 #include "settings.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "symboldatabase.h"
 #include "errorlogger.h"
 #include "errortypes.h"
--- ./lib/checkfunctions.cpp.orig	2025-05-09 12:57:15.222240616 -0500
+++ ./lib/checkfunctions.cpp	2025-05-09 12:57:40.322238914 -0500
@@ -28,7 +28,7 @@
 #include "mathlib.h"
 #include "platform.h"
 #include "settings.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "symboldatabase.h"
 #include "token.h"
 #include "tokenize.h"
--- ./lib/checkother.cpp.orig	2025-05-09 12:58:29.222240882 -0500
+++ ./lib/checkother.cpp	2025-05-09 12:58:57.422239839 -0500
@@ -26,7 +26,7 @@
 #include "mathlib.h"
 #include "platform.h"
 #include "settings.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "symboldatabase.h"
 #include "token.h"
 #include "tokenize.h"
--- ./lib/checkstl.cpp.orig	2025-05-09 12:59:53.431054472 -0500
+++ ./lib/checkstl.cpp	2025-05-09 13:00:08.922239909 -0500
@@ -24,7 +24,7 @@
 #include "mathlib.h"
 #include "pathanalysis.h"
 #include "settings.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "symboldatabase.h"
 #include "token.h"
 #include "tokenize.h"
--- ./lib/checktype.cpp.orig	2025-05-09 13:01:08.143712213 -0500
+++ ./lib/checktype.cpp	2025-05-09 13:01:24.222385810 -0500
@@ -25,7 +25,7 @@
 #include "mathlib.h"
 #include "platform.h"
 #include "settings.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "symboldatabase.h"
 #include "token.h"
 #include "tokenize.h"
--- ./lib/cppcheck.vcxproj.filters.orig	2025-05-09 13:04:39.922240913 -0500
+++ ./lib/cppcheck.vcxproj.filters	2025-05-09 13:04:57.922240840 -0500
@@ -496,7 +496,7 @@
     <ClInclude Include="smallvector.h">
       <Filter>Header Files</Filter>
     </ClInclude>
-    <ClInclude Include="standards.h">
+    <ClInclude Include="cppcheckstd.h">
       <Filter>Header Files</Filter>
     </ClInclude>
     <ClInclude Include="valueptr.h">
--- ./lib/cppcheck.vcxproj.orig	2025-05-09 13:09:10.722239644 -0500
+++ ./lib/cppcheck.vcxproj	2025-05-09 13:09:40.722241643 -0500
@@ -159,7 +159,7 @@
     <ClInclude Include="settings.h" />
     <ClInclude Include="smallvector.h" />
     <ClInclude Include="sourcelocation.h" />
-    <ClInclude Include="standards.h" />
+    <ClInclude Include="cppcheckstd.h" />
     <ClInclude Include="summaries.h" />
     <ClInclude Include="suppressions.h" />
     <ClInclude Include="symboldatabase.h" />
--- ./lib/filesettings.h.orig	2025-05-09 13:12:07.322239702 -0500
+++ ./lib/filesettings.h	2025-05-09 13:12:27.722851492 -0500
@@ -22,7 +22,7 @@
 #include "config.h"
 #include "path.h"
 #include "platform.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 
 #include <list>
 #include <set>
--- ./lib/path.h.orig	2025-05-09 13:15:31.832251828 -0500
+++ ./lib/path.h	2025-05-09 13:15:46.222250277 -0500
@@ -22,7 +22,7 @@
 //---------------------------------------------------------------------------
 
 #include "config.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 
 #include <set>
 #include <string>
--- ./lib/preprocessor.cpp.orig	2025-05-09 13:17:09.940031977 -0500
+++ ./lib/preprocessor.cpp	2025-05-09 13:17:24.222528240 -0500
@@ -25,7 +25,7 @@
 #include "path.h"
 #include "platform.h"
 #include "settings.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "suppressions.h"
 #include "utils.h"
 
--- ./lib/symboldatabase.cpp.orig	2025-05-09 13:18:50.182220672 -0500
+++ ./lib/symboldatabase.cpp	2025-05-09 13:19:04.822253482 -0500
@@ -28,7 +28,7 @@
 #include "path.h"
 #include "platform.h"
 #include "settings.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "templatesimplifier.h"
 #include "token.h"
 #include "tokenize.h"
--- ./lib/templatesimplifier.cpp.orig	2025-05-09 13:19:41.222477650 -0500
+++ ./lib/templatesimplifier.cpp	2025-05-09 13:19:56.422251963 -0500
@@ -22,7 +22,7 @@
 #include "errortypes.h"
 #include "mathlib.h"
 #include "settings.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "token.h"
 #include "tokenize.h"
 #include "tokenlist.h"
--- ./lib/tokenize.cpp.orig	2025-05-09 13:20:28.922248785 -0500
+++ ./lib/tokenize.cpp	2025-05-09 13:20:43.522251103 -0500
@@ -28,7 +28,7 @@
 #include "platform.h"
 #include "preprocessor.h"
 #include "settings.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "summaries.h"
 #include "symboldatabase.h"
 #include "templatesimplifier.h"
--- ./lib/valueflow.cpp.orig	2025-05-09 13:21:41.463903872 -0500
+++ ./lib/valueflow.cpp	2025-05-09 13:22:00.522249183 -0500
@@ -96,7 +96,7 @@
 #include "settings.h"
 #include "smallvector.h"
 #include "sourcelocation.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "symboldatabase.h"
 #include "timer.h"
 #include "token.h"
--- ./test/testconstructors.cpp.orig	2025-05-12 09:31:00.862250421 -0500
+++ ./test/testconstructors.cpp	2025-05-12 09:31:19.462251837 -0500
@@ -20,7 +20,7 @@
 #include "errortypes.h"
 #include "fixture.h"
 #include "helpers.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "settings.h"
 
 #include <cstddef>
--- ./test/testfunctions.cpp.orig	2025-05-12 09:32:53.183632856 -0500
+++ ./test/testfunctions.cpp	2025-05-12 09:33:12.462254980 -0500
@@ -22,7 +22,7 @@
 #include "helpers.h"
 #include "platform.h"
 #include "settings.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 
 #include <cstddef>
 #include <string>
--- ./test/testlibrary.cpp.orig	2025-05-12 09:33:59.462250043 -0500
+++ ./test/testlibrary.cpp	2025-05-12 09:34:15.162257045 -0500
@@ -21,7 +21,7 @@
 #include "helpers.h"
 #include "library.h"
 #include "settings.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "token.h"
 #include "tokenlist.h"
 
--- ./test/testsimplifytokens.cpp.orig	2025-05-12 09:35:51.562251715 -0500
+++ ./test/testsimplifytokens.cpp	2025-05-12 09:36:05.662089630 -0500
@@ -20,7 +20,7 @@
 #include "helpers.h"
 #include "platform.h"
 #include "settings.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "fixture.h"
 #include "token.h"
 
--- ./test/teststl.cpp.orig	2025-05-12 09:36:37.686357700 -0500
+++ ./test/teststl.cpp	2025-05-12 09:36:50.881845730 -0500
@@ -21,7 +21,7 @@
 #include "fixture.h"
 #include "helpers.h"
 #include "settings.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "utils.h"
 
 #include <cstddef>
--- ./test/testtokenize.cpp.orig	2025-05-12 10:06:12.862240908 -0500
+++ ./test/testtokenize.cpp	2025-05-12 10:06:26.362241247 -0500
@@ -22,7 +22,7 @@
 #include "platform.h"
 #include "preprocessor.h" // usually tests here should not use preprocessor...
 #include "settings.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "token.h"
 #include "tokenize.h"
 #include "tokenlist.h"
--- ./lib/keywords.h.orig	2025-05-19 06:20:44.123046161 -0500
+++ ./lib/keywords.h	2025-05-19 06:21:04.428485970 -0500
@@ -19,7 +19,7 @@
 #ifndef keywordsH
 #define keywordsH
 
-#include "standards.h"
+#include "cppcheckstd.h"
 
 #include <string>
 #include <unordered_set>
--- ./lib/standards.cpp.orig	2025-05-19 06:23:02.473101299 -0500
+++ ./lib/standards.cpp	2025-05-19 06:23:17.288256376 -0500
@@ -16,7 +16,7 @@
  * along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "utils.h"
 
 #include <utility>
--- ./lib/cppcheck.cpp.orig	2026-02-23 23:10:25.793858381 -0600
+++ ./lib/cppcheck.cpp	2026-02-23 23:11:07.718030725 -0600
@@ -33,7 +33,7 @@
 #include "platform.h"
 #include "preprocessor.h"
 #include "settings.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "suppressions.h"
 #include "symboldatabase.h"
 #include "timer.h"
--- ./lib/importproject.cpp.orig	2026-02-23 23:16:12.043238583 -0600
+++ ./lib/importproject.cpp	2026-02-23 23:16:26.607613445 -0600
@@ -21,7 +21,7 @@
 #include "path.h"
 #include "pathmatch.h"
 #include "settings.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "suppressions.h"
 #include "token.h"
 #include "tokenlist.h"
--- ./lib/tokenlist.cpp.orig	2026-02-23 23:17:12.055067032 -0600
+++ ./lib/tokenlist.cpp	2026-02-23 23:17:42.857329495 -0600
@@ -28,7 +28,7 @@
 #include "path.h"
 #include "platform.h"
 #include "settings.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "token.h"
 
 #include <algorithm>
--- ./test/testother.cpp.orig	2026-02-23 23:21:03.810114674 -0600
+++ ./test/testother.cpp	2026-02-23 23:21:16.301267512 -0600
@@ -22,7 +22,7 @@
 #include "helpers.h"
 #include "platform.h"
 #include "settings.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 
 #include <cstddef>
 #include <sstream>
--- ./test/testtype.cpp.orig	2026-02-23 23:22:05.656581557 -0600
+++ ./test/testtype.cpp	2026-02-23 23:22:17.457120788 -0600
@@ -22,7 +22,7 @@
 #include "helpers.h"
 #include "platform.h"
 #include "settings.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 
 #include <cstddef>
 #include <string>
--- ./test/testvarid.cpp.orig	2026-02-23 23:22:56.104206557 -0600
+++ ./test/testvarid.cpp	2026-02-23 23:23:05.290209096 -0600
@@ -19,7 +19,7 @@
 #include "helpers.h"
 #include "platform.h"
 #include "settings.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "fixture.h"
 #include "token.h"
 
--- ./lib/tokenlist.h.orig	2026-02-23 23:23:47.340813072 -0600
+++ ./lib/tokenlist.h	2026-02-23 23:23:58.660210783 -0600
@@ -22,7 +22,7 @@
 //---------------------------------------------------------------------------
 
 #include "config.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 
 #include <cstddef>
 #include <cstdint>
--- ./cli/cmdlineparser.h.orig	2026-02-23 23:38:53.973044610 -0600
+++ ./cli/cmdlineparser.h	2026-02-23 23:39:06.498051470 -0600
@@ -27,7 +27,7 @@
 
 #include "cmdlinelogger.h"
 #include "filesettings.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "utils.h"
 
 class Settings;
--- ./cli/filelister.cpp.orig	2026-02-23 23:39:14.457795404 -0600
+++ ./cli/filelister.cpp	2026-02-23 23:39:29.803510121 -0600
@@ -25,7 +25,7 @@
 #include "filesettings.h"
 #include "path.h"
 #include "pathmatch.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "utils.h"
 
 #include <cstring>
--- ./lib/preprocessor.h.orig	2026-02-23 23:50:30.026147045 -0600
+++ ./lib/preprocessor.h	2026-02-23 23:50:39.503396212 -0600
@@ -22,7 +22,7 @@
 //---------------------------------------------------------------------------
 
 #include "config.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 
 #include <cstddef>
 #include <cstdint>
--- ./frontend/frontend.h.orig	2026-02-23 23:54:45.210408610 -0600
+++ ./frontend/frontend.h	2026-02-23 23:54:56.259389105 -0600
@@ -19,7 +19,7 @@
 #ifndef FRONTEND_H
 #define FRONTEND_H
 
-#include "standards.h"
+#include "cppcheckstd.h"
 
 #include <list>
 
--- ./lib/platform.h.orig	2026-03-24 00:58:42.508049955 -0500
+++ ./lib/platform.h	2026-03-24 00:58:56.268030285 -0500
@@ -23,7 +23,7 @@
 
 #include "config.h"
 #include "mathlib.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "utils.h"
 
 #include <cassert>
--- ./lib/library.h.orig	2026-07-10 07:37:32.009299862 -0500
+++ ./lib/library.h	2026-07-10 07:37:53.355474038 -0500
@@ -23,7 +23,7 @@
 
 #include "config.h"
 #include "mathlib.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 
 #include <array>
 #include <cstdint>
--- ./lib/settings.h.orig	2026-07-10 07:38:39.723130233 -0500
+++ ./lib/settings.h	2026-07-10 07:38:52.494743010 -0500
@@ -25,7 +25,7 @@
 #include "config.h"
 #include "library.h"
 #include "platform.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "checkers.h"
 
 #include <algorithm>
--- ./test/testcmdlineparser.cpp.orig	2026-07-10 07:39:12.999882036 -0500
+++ ./test/testcmdlineparser.cpp	2026-07-10 07:39:25.541509418 -0500
@@ -29,7 +29,7 @@
 #include "platform.h"
 #include "redirect.h"
 #include "settings.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "suppressions.h"
 #include "utils.h"
 
--- ./cli/cmdlineparser.cpp.orig	2026-07-10 07:39:48.741769842 -0500
+++ ./cli/cmdlineparser.cpp	2026-07-10 07:39:59.690998048 -0500
@@ -35,7 +35,7 @@
 #include "pathmatch.h"
 #include "platform.h"
 #include "settings.h"
-#include "standards.h"
+#include "cppcheckstd.h"
 #include "suppressions.h"
 #include "utils.h"
 