--- ./src/threads.h_orig	2020-08-22 09:45:05 +0000
+++ ./src/threads.h	2020-08-22 09:45:16 +0000
@@ -74,7 +74,7 @@
         be used and this will be filled.*/
     cr_CompressionType type; /*!<
         Type of compression to use */
-    cr_ContentStat *stat; /*!<
+    cr_ContentStat *stat_c; /*!<
         Stats of compressed file or NULL */
     char *zck_dict_dir; /*!<
         Location of zchunk dictionaries */
--- ./src/threads.c_orig	2020-08-22 09:46:02 +0000
+++ ./src/threads.c	2020-08-22 09:47:48 +0000
@@ -38,7 +38,7 @@
                        int delsrc,
                        GError **err)
 {
-    cr_ContentStat *stat;
+    cr_ContentStat *stat_t;
     cr_CompressionTask *task;
 
     assert(src);
@@ -46,8 +46,8 @@
     assert(checksum_type < CR_CHECKSUM_SENTINEL);
     assert(!err || *err == NULL);
 
-    stat = cr_contentstat_new(checksum_type, err);
-    if (!stat)
+    stat_t = cr_contentstat_new(checksum_type, err);
+    if (!stat_t)
         return NULL;
 
     task = g_malloc0(sizeof(cr_CompressionTask));
@@ -60,7 +60,7 @@
     task->src    = g_strdup(src);
     task->dst    = g_strdup(dst);
     task->type   = compression_type;
-    task->stat   = stat;
+    task->stat_c   = stat_t;
     if (zck_dict_dir != NULL)
         task->zck_dict_dir = g_strdup(zck_dict_dir);
     task->zck_auto_chunk = zck_auto_chunk;
@@ -79,7 +79,7 @@
 
     g_free(task->src);
     g_free(task->dst);
-    cr_contentstat_free(task->stat, err);
+    cr_contentstat_free(task->stat_c, err);
     if (task->err)
         g_error_free(task->err);
     if (task->zck_dict_dir)
@@ -104,7 +104,7 @@
     cr_compress_file_with_stat(task->src,
                                task->dst,
                                task->type,
-                               task->stat,
+                               task->stat_c,
                                task->zck_dict_dir,
                                task->zck_auto_chunk,
                                &tmp_err);
@@ -132,7 +132,7 @@
                                     task->type,
                                     ud->package_count,
                                     ud->task_count - ud->skipped_count,
-                                    task->stat,
+                                    task->stat_c,
                                     task->zck_dict_dir,
                                     &tmp_err);
 
--- ./src/createrepo_c.c_orig	2020-08-22 10:03:01 +0000
+++ ./src/createrepo_c.c	2020-08-22 10:04:00 +0000
@@ -436,8 +436,8 @@
         *exit_val = 2;
     }else{
         cr_contentstat_free(*content_stat, NULL);
-        *content_stat = task->stat;
-        task->stat = NULL;
+        *content_stat = task->stat_c;
+        task->stat_c = NULL;
     }
 }
 
@@ -1940,11 +1940,11 @@
         g_free(fex_db_name);
         g_free(oth_db_name);
 
-        cr_repomd_record_load_contentstat(pri_db_rec, pri_db_task->stat);
-        cr_repomd_record_load_contentstat(fil_db_rec, fil_db_task->stat);
+        cr_repomd_record_load_contentstat(pri_db_rec, pri_db_task->stat_c);
+        cr_repomd_record_load_contentstat(fil_db_rec, fil_db_task->stat_c);
         if (cmd_options->filelists_ext)
-            cr_repomd_record_load_contentstat(fex_db_rec, fex_db_task->stat);
-        cr_repomd_record_load_contentstat(oth_db_rec, oth_db_task->stat);
+            cr_repomd_record_load_contentstat(fex_db_rec, fex_db_task->stat_c);
+        cr_repomd_record_load_contentstat(oth_db_rec, oth_db_task->stat_c);
 
         cr_compressiontask_free(pri_db_task, NULL);
         cr_compressiontask_free(fil_db_task, NULL);
--- ./src/mergerepo_c.c_orig    2025-10-23 00:53:22.480605173 -0500
+++ ./src/mergerepo_c.c 2025-10-23 00:54:56.449598165 -0500
@@ -1681,11 +1681,11 @@
         g_free(fex_db_c_filename);
         g_free(oth_db_c_filename);
 
-        cr_repomd_record_load_contentstat(pri_db_rec, pri_db_task->stat);
-        cr_repomd_record_load_contentstat(fil_db_rec, fil_db_task->stat);
+        cr_repomd_record_load_contentstat(pri_db_rec, pri_db_task->stat_c);
+        cr_repomd_record_load_contentstat(fil_db_rec, fil_db_task->stat_c);
         if (cmd_options->filelists_ext)
-            cr_repomd_record_load_contentstat(fex_db_rec, fex_db_task->stat);
-        cr_repomd_record_load_contentstat(oth_db_rec, oth_db_task->stat);
+            cr_repomd_record_load_contentstat(fex_db_rec, fex_db_task->stat_c);
+        cr_repomd_record_load_contentstat(oth_db_rec, oth_db_task->stat_c);
 
         cr_compressiontask_free(pri_db_task, NULL);
         cr_compressiontask_free(fil_db_task, NULL);
--- ./src/sqliterepo_c.c_orig	2020-08-22 10:08:45 +0000
+++ ./src/sqliterepo_c.c	2020-08-22 10:09:06 +0000
@@ -430,9 +430,9 @@
     g_free(oth_db_name);
 
     // Fill repomd records from stats gathered during compression
-    cr_repomd_record_load_contentstat(pri_db_rec, pri_db_task->stat);
-    cr_repomd_record_load_contentstat(fil_db_rec, fil_db_task->stat);
-    cr_repomd_record_load_contentstat(oth_db_rec, oth_db_task->stat);
+    cr_repomd_record_load_contentstat(pri_db_rec, pri_db_task->stat_c);
+    cr_repomd_record_load_contentstat(fil_db_rec, fil_db_task->stat_c);
+    cr_repomd_record_load_contentstat(oth_db_rec, oth_db_task->stat_c);
 
     // Free the compression tasks
     cr_compressiontask_free(pri_db_task, NULL);