--- ./dnf/const.py.in_orig	2024-12-12 03:14:32.679747652 -0600
+++ ./dnf/const.py.in	2024-12-12 03:15:29.307403929 -0600
@@ -20,8 +20,8 @@
 
 from __future__ import unicode_literals
 
-CONF_FILENAME='/etc/dnf/dnf.conf' # :api
-CONF_AUTOMATIC_FILENAME='/etc/dnf/automatic.conf'
+CONF_FILENAME='/opt/freeware/etc/dnf/dnf.conf' # :api
+CONF_AUTOMATIC_FILENAME='/opt/freeware/etc/dnf/automatic.conf'
 DISTROVERPKG=('system-release(releasever)', 'system-release',
               'distribution-release(releasever)', 'distribution-release',
               'redhat-release', 'suse-release')
@@ -48,7 +48,7 @@
 
 PREFIX=NAME.lower()
 PROGRAM_NAME=NAME.lower()  # Deprecated - no longer used, Argparser prints program name based on sys.argv
-PLUGINCONFPATH = '/etc/dnf/plugins'  # :api
+PLUGINCONFPATH = '/opt/freeware/etc/dnf/plugins'  # :api
 PLUGINPATH = '@PYTHON_INSTALL_DIR@/dnf-plugins'
 VERSION='@DNF_VERSION@'
 USER_AGENT = "dnf/%s" % VERSION
--- ./dnf/automatic/main.py_orig	2024-12-12 03:15:42.710538652 -0600
+++ ./dnf/automatic/main.py	2024-12-12 03:16:11.905935273 -0600
@@ -184,7 +184,7 @@
     def __init__(self):
         super(CommandsConfig, self).__init__()
         self.add_option('apply_updates', libdnf.conf.OptionBool(False))
-        self.add_option('base_config_file', libdnf.conf.OptionString('/etc/dnf/dnf.conf'))
+        self.add_option('base_config_file', libdnf.conf.OptionString('/opt/freeware/etc/dnf/dnf.conf'))
         self.add_option('download_updates', libdnf.conf.OptionBool(False))
         self.add_option('upgrade_type', libdnf.conf.OptionEnumString('default',
                         libdnf.conf.VectorString(['default', 'security'])))
--- ./dnf/conf/substitutions.py_orig	2024-12-12 03:16:23.257416882 -0600
+++ ./dnf/conf/substitutions.py	2024-12-12 03:18:05.287430263 -0600
@@ -74,7 +74,7 @@
         # type: (str) -> bool
         return key in READ_ONLY_VARIABLES
 
-    def update_from_etc(self, installroot, varsdir=("/etc/yum/vars/", "/etc/dnf/vars/")):
+    def update_from_etc(self, installroot, varsdir=("/opt/freeware/etc/yum/vars/", "/opt/freeware/etc/dnf/vars/")):
         # :api
 
         for vars_path in varsdir:
--- ./dnf/cli/aliases.py_orig	2024-12-12 03:18:09.124886824 -0600
+++ ./dnf/cli/aliases.py	2024-12-12 03:18:27.500079785 -0600
@@ -33,7 +33,7 @@
 
 logger = logging.getLogger('dnf')
 
-ALIASES_DROPIN_DIR = '/etc/dnf/aliases.d/'
+ALIASES_DROPIN_DIR = '/opt/freeware/etc/dnf/aliases.d/'
 ALIASES_CONF_PATH = os.path.join(ALIASES_DROPIN_DIR, 'ALIASES.conf')
 ALIASES_USER_PATH = os.path.join(ALIASES_DROPIN_DIR, 'USER.conf')
 
--- ./CMakeLists.txt_orig	2024-12-12 03:18:50.338343566 -0600
+++ ./CMakeLists.txt	2024-12-12 03:19:43.703857919 -0600
@@ -3,8 +3,8 @@
 
 INCLUDE (${CMAKE_SOURCE_DIR}/VERSION.cmake)
 
-SET( SYSCONFDIR /etc)
-SET( SYSTEMD_DIR /usr/lib/systemd/system)
+SET( SYSCONFDIR /opt/freeware/etc)
+SET( SYSTEMD_DIR /opt/freeware/lib/systemd/system)
 
 IF (NOT PYTHON_DESIRED)
     FIND_PACKAGE (PythonInterp REQUIRED)
--- ./doc/CMakeLists.txt_orig	2024-12-20 04:27:00.551283939 -0600
+++ ./doc/CMakeLists.txt	2024-12-20 04:27:06.321758849 -0600
@@ -25,7 +25,7 @@
               ${CMAKE_CURRENT_BINARY_DIR}/yum2dnf.8
               ${CMAKE_CURRENT_BINARY_DIR}/yum.8
               ${CMAKE_CURRENT_BINARY_DIR}/yum-shell.8
-              DESTINATION share/man/man8)
+              DESTINATION /opt/freeware/man/man5)
     INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/dnf4.conf.5
               ${CMAKE_CURRENT_BINARY_DIR}/yum.conf.5
               ${CMAKE_CURRENT_BINARY_DIR}/dnf4-transaction-json.5
--- ./etc/logrotate.d/CMakeLists.txt_orig	2024-12-12 03:20:44.383584760 -0600
+++ ./etc/logrotate.d/CMakeLists.txt	2024-12-12 03:21:14.838613095 -0600
@@ -1,1 +1,1 @@
-INSTALL (FILES "dnf" DESTINATION ${SYSCONFDIR}/logrotate.d)
+INSTALL (FILES "dnf" DESTINATION /opt/freeware/etc/dnf/logrotate.d)
--- ./doc/CMakeLists.txt_orig	2024-12-20 06:08:55.906299939 -0600
+++ ./doc/CMakeLists.txt	2024-12-20 06:14:14.757528590 -0600
@@ -19,6 +19,7 @@
 ADD_CUSTOM_TARGET (doc)
 ADD_DEPENDENCIES (doc doc-html doc-man)
 
+SET(WITH_MAN 0)
 if (NOT WITH_MAN EQUAL 0)
     INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/dnf4.8
               ${CMAKE_CURRENT_BINARY_DIR}/dnf-automatic.8